#include <string>
using namespace std;

#include "boost/multi_array.hpp"

unsigned int levenshteindistance(const string& s, const string& t)
{
	unsigned int m = s.length();
	unsigned int n = t.length();
	
	boost::multi_array<unsigned int, 2> d;
	d.resize(boost::extents[m+1][n+1]);
	
	for (unsigned int i=0;i<m+1;i++)
	{
		d[i][0]=i;
	}
	
	
	for (unsigned int j=0;j<n+1;j++)
	{
		d[0][j]=j;
	}
	
	
	for (unsigned int i=1;i<m+1;i++)
	{
		for (unsigned int j=1;j<n+1;j++)
		{
			unsigned int cost;
			if (tolower(s[i-1])==tolower(t[j-1]))
				cost=0;
			else
				cost=1;
			
			d[i][j]=min(
						d[i-1][j]+1,//deletion
						min(d[i][j-1]+1,//insertion
						d[i-1][j-1]+cost//substitution
						));
		}
	}
	
	/*
	for (unsigned int i=0;i<m+1;i++)
	{
		for (unsigned int j=0;j<n+1;j++)
		{
			std::cout<<d[i][j]<<",";
		}
		std::cout<<"\n";
	}*/
	
	return d[m][n];
}