/*

 todo: set quantities
 todo: tie widget quntities to game variables
 todo: set up timeline
 todo: set up dynamics
 todo: set up dialogs
 todo: release resources?
 todo: allow events to, like, end the game, or whatever
 todo: playsample doesn't seem to work:/
 todo: when pop bars move left, blood spatter
 todo: as population decreases, blot out parts of the city
 todo: as population increases, add new bits in(i guess)

 todo: ALLOW INGAME RESTART
 */
#include <allegro.h>
#include <iostream>
#include <vector>
#include <list>
#include <time.h>
#include <algorithm>
#include "boost/foreach.hpp"

using namespace std;

#define foreach BOOST_FOREACH

typedef float num;

BITMAP* buffer;

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"
#include "printwrap.hpp"
#include "conversationdat.hpp"


const int ts=13;
char *statustext="";
bool warover=false;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;

vector<string> emergencymessages;

char *nulltext="";


void enable_buttons();


int consequences=0;

void drawPreface()
{
	clear_to_color(buffer, makecol(0,0,0));
}

bool escpressed;

class IntroLoop
{
public:
	static void initialize()
	{
		escpressed=true;
		speed_count=0;
		titletimer=0;
		finishedtitle=false;
	}

	static bool quitcondition()
	{
		return quit||warover||finishedtitle;
	}

	static void logic()
	{
		titletimer++;

		if (titletimer>6000||(mouse_b&1)||keypressed())
		{
			position_mouse(400,200);
			finishedtitle=true;
		}
	}

	static void draw()
	{
		clear_to_color(buffer,makecol(0,0,0));

		textout_ex(buffer, font, "increpare presents", 4, 50, makecol(rand()%255,rand()%255,rand()%255), makecol(0,0,0));
	}
};

class TitleLoop
{
private:
	static bool begin;
	static int selected;
	static bool upheld;
	static bool downheld;
	static bool spaceheld;
public:
	static void initialize()
	{
		begin=false;
		selected=0;
		upheld=true;
		downheld=true;
		spaceheld=true;
		escpressed=true;
	}

	static void logic()
	{
		if (key[KEY_ESC]&&!escpressed)
			quit=true;
		escpressed=key[KEY_ESC];

		if (key[KEY_UP])
		{
			if (!upheld)
			{
				selected=(selected+1)%2;
				upheld=true;
			}
		}
		else
			upheld=false;

		if (key[KEY_DOWN])
		{
			if (!downheld)
			{
				selected=(selected+1)%2;
				downheld=true;
			}
		}
		else
			downheld=false;

		if (key[KEY_SPACE])
		{
			if (!spaceheld)
			{
				if (selected==0)
				{
					begin=true;
				}
				else
				{
					quit=true;
				}
			}
		}
		else
			spaceheld=false;

	}

	static bool quitcondition()
	{
		return quit||begin;
	}

	static void draw()
	{
		clear_to_color(buffer,makecol(0,0,0));
		textout_ex(buffer,font,"Triptych",51,31,makecol(255,255,255),makecol(0,0,0));
		if (selected==0)
		{
			textout_ex(buffer,font,"Begin",59,60,makecol(100,100,100),makecol(255,255,255));
			textout_ex(buffer,font,"Leave",59,82,makecol(255,255,255),makecol(0,0,0));
		}
		else
		{
			textout_ex(buffer,font,"Begin",59,60,makecol(255,255,255),makecol(0,0,0));
			textout_ex(buffer,font,"Leave",59,82,makecol(100,100,100),makecol(255,255,255));
		}

	}

};

bool TitleLoop::begin=false;
int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;

bool pressed[5];
unsigned int curselected;
enum GameState {
	gs_selecting,
	gs_weather,
	gs_action
} gamestate;

string displaystring;
int turn;
const int maxturn=8;

class GameLoop
{
public:
	static void initialize()
	{

		consequences=false;
		warover=false;
		leave=false;
		insertbasicdata();
		selectconversations();
		calcmaxscore();
		escpressed=true;


		for (int i=0;i<5;i++)
			pressed[i]=true;
		curselected=0;
		gamestate=gs_selecting;
		switch (rand()%5)
		{
			case 0:
				displaystring="i feel so, so pensive today...";
				break;
			case 1:
				displaystring="i can't remember the last time i felt this way.";
				break;
			case 2:
				displaystring="there's something about this place that always brings these emotions back to me.";
				break;
			case 3:
				displaystring="i feel like i'm loosing control...";
				break;
			case 4:
				displaystring="why can't i just pull myself together?";
				break;
			case 5:
				displaystring="i'm feeling so...so happy today";
				break;
		}
		turn=0;

	}

	static bool quitcondition()
	{
		return quit||leave||warover;
	}

	static void logic()
	{
		unsigned int tarselect=curselected;

		if (key[KEY_UP]&&!pressed[0]&&gamestate==gs_selecting)
		{
			tarselect=(curselected+2) % 4;
		}
		else if (key[KEY_DOWN]&&!pressed[1]&&gamestate==gs_selecting)
		{
			tarselect=(curselected+2) % 4;
		}
		else if (key[KEY_LEFT]&&!pressed[2]&&gamestate==gs_selecting)
		{
			if (curselected==1 || curselected==3)
				tarselect=curselected-1;
			else
				tarselect=curselected+1;
		}
		else if (key[KEY_RIGHT]&&!pressed[3]&&gamestate==gs_selecting)
		{
			if (curselected==1 || curselected==3)
				tarselect=curselected-1;
			else
				tarselect=curselected+1;		}

		if (canselect(tarselect))
		{
			curselected=tarselect;
		}

		if (key[KEY_SPACE]&&!pressed[4]&&gamestate==gs_selecting)
		{
			if (selectedweather.size()>0)
			{
				gamestate=gs_weather;

				displaystring=traumafilter(*(selectedweather.begin()),turn);
				selectedweather.pop_front();
			}
			else
			{
				list <Conv>::iterator it=selectedconv.begin();
				for (unsigned int i=0;i<curselected;i++)
				{
					it++;
				}
				displaystring=traumafilter(it->res,turn);
				gamestate=gs_action;
			}
		}
		else if (key[KEY_SPACE]&&!pressed[4]&&gamestate==gs_weather)
		{
			list <Conv>::iterator it=selectedconv.begin();
			for (unsigned int i=0;i<curselected;i++)
			{
				it++;
			}
			displaystring=traumafilter(it->res,turn);
			gamestate=gs_action;
		}
		else if (key[KEY_SPACE]&&!pressed[4]&&gamestate==gs_action)
		{
			chooseconv(curselected);
			if (curselected>=selectedconv.size())
				curselected=selectedconv.size()-1;
			gamestate=gs_selecting;
			displaystring="";
			turn++;
			if (selectedconv.size()==0)
				leave=true;
		}


		if (key[KEY_ESC]&&!escpressed)
			leave=true;
		escpressed=key[KEY_ESC];

		pressed[0]=key[KEY_UP];
		pressed[1]=key[KEY_DOWN];
		pressed[2]=key[KEY_LEFT];
		pressed[3]=key[KEY_RIGHT];
		pressed[4]=key[KEY_SPACE];
	}

	static void draw()
	{
		clear_to_color(buffer,makecol(0,0,0));
		rect(buffer, 0, 74, 79, 96, makecol(255,255,255));
		rect(buffer, 80, 74, 159, 96, makecol(255,255,255));
		rect(buffer, 0, 97, 79, 119, makecol(255,255,255));
		rect(buffer, 80, 97, 159, 119, makecol(255,255,255));
		wrapprint(displaystring, 4, 4);

		{
			list <Conv>::iterator it=selectedconv.begin();
			if (selectedconv.size()>0)
			{
				wrapprint(it->task.c_str() , 4, 77,9);
			}
			if (selectedconv.size()>1)
			{
				it++;
				wrapprint(it->task.c_str() , 84, 77,9);
			}
			if (selectedconv.size()>2)
			{
				it++;
				wrapprint(it->task.c_str() , 4, 100,9);
			}
			if (selectedconv.size()>3)
			{
				it++;
				wrapprint(it->task.c_str() , 84, 100,9);
			}
		}

		if (gamestate==gs_selecting)
		{
			switch (curselected)
			{
				case 0:
					rect(buffer, 1, 75, 78, 95, makecol(255,255,255));
					break;
				case 1:
					rect(buffer, 81, 75, 158, 95, makecol(255,255,255));
					break;
				case 2:
					rect(buffer, 1, 98, 78, 118, makecol(255,255,255));
					break;
				case 3:
					rect(buffer, 81, 98, 158, 118, makecol(255,255,255));
					break;
			}

		}
		else
		{
		}

	}

};

template<class T>
void loop()
{

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

//			if (key[KEY_ESC])
//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
	}
}




void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(30));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	//init the buffer
	buffer=create_bitmap(160,120);

	srand(time(0));
}

int dir;
int px;
int py;

int main(int argc, char *argv[])
{
	init();

	loop<IntroLoop>();

	playmusic(1);

	while (!quit)
	{
		loop<TitleLoop>();

		loop<GameLoop>();
	}

	return 0;
}
END_OF_MAIN()
